/*
 * ANTLR-generated file resulting from grammar v810.g
 * 
 * Terence Parr, MageLang Institute
 * with John Lilley, Empathy Software
 * ANTLR Version 2.4.0; 1996,1997
 */
import java.io.IOException;
import antlr.Tokenizer;
import antlr.TokenBuffer;
import antlr.LLkParser;
import antlr.Token;
import antlr.ParserException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.collections.impl.BitSet;

import java.io.*;

public class V810Asm extends antlr.LLkParser
       implements V810TokenTypes
 {

	// Define a generica array that can hold our Instruction and modifiers, along
	// with some extra details...
	// format: 
	//   0) 'opcode type' (10,20,30,40,50,60,61,70,80,etc...)
	//   1) full Instruction
	//   2) opcode (00000..11111)
	//   3)var1
	//   4)var2
	//   5)var3
	//   6)etc...
	private int[] op_format = {0,0,0,0,0,0,0,0}; // array of 8, for padding...

	// Buffer to hold DB. valuse...
	private int[] defBuff = new int[256];

	// PC, used to help .org defines
	long tmp_PC = 0;

	//The OBJ Output
	private static RandomAccessFile dout = null;

	//Define a Inst type
	// Define a main
	public static void main(String[] args) { //static
                
		// Use a try/catch block for parser exceptions
		try {
			// if we have at least one command-line argument
			if (args.length > 0 ) {
				System.err.println("Parsing...");

				// for each directory/file specified on the command line
				for(int i=0; i< args.length;i++)
					doFile(new File(args[i])); // parse it
			} else {
				System.err.println("Usage: java V810Asm "+"<file>");
			}
		} catch(Exception e) {
			System.err.println("exception: "+e);
			e.printStackTrace(System.err);   // so we can get stack trace
		}
	}

	// This method decides what action to take based on the type of
	//   file we are looking at
	public static void doFile(File f) throws Exception {
		// If this is a directory, Return, were not smart enoug to handle them =0)
		if (f.isDirectory()) return;

		// otherwise, if this is a V810 file, parse it!
		else if ((f.getName().length()>4) && f.getName().substring(f.getName().length()-4).equals(".asm")) {
			System.err.println("   "+f.getAbsolutePath());
			//Open our output file....
			File obj = new File(f.getName().substring(0,f.getName().length()-4)+".obj");
			dout = new RandomAccessFile(obj, "rw");

			parseFile(new FileInputStream(f));
                        
			dout.close();
		}
	}

	// Here's where we do the real work...
	public static void parseFile(InputStream s) throws Exception {
		try {
			// Create a scanner that reads from the input stream passed to us
			V810Lexer lexer = new V810Lexer(s);

			// Create a parser that reads from the scanner
			V810Asm parser = new V810Asm(lexer);

			// start parsing at the compilationUnit rule
			parser.compilationUnit();
		} catch (Exception e) {
			System.err.println("parser exception: "+e);
			e.printStackTrace();   // so we can get stack trace             
		}
	}

protected V810Asm(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
}

public V810Asm(TokenBuffer tokenBuf) {
  this(tokenBuf,2);
}

protected V810Asm(Tokenizer lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
}

public V810Asm(Tokenizer lexer) {
  this(lexer,2);
}

	public final void compilationUnit() throws ParserException, IOException {
		
		
		tmp_PC=org();
		if ( guessing==0 ) {
			tmp_PC = (tmp_PC & 0xFFFFFFFC);
		}
		{
		_loop3:
		do {
			switch ( LA(1)) {
			case LITERAL_org:
			case LITERAL_db:
			case LITERAL_dh:
			case LITERAL_dw:
			case LITERAL_ds:
			{
				preProc();
				break;
			}
			case LITERAL_sub:
			case LITERAL_jmp:
			case LITERAL_mul:
			case LITERAL_div:
			case LITERAL_mulu:
			case LITERAL_divu:
			case LITERAL_or:
			case LITERAL_and:
			case LITERAL_xor:
			case LITERAL_not:
			case LITERAL_mov:
			case LITERAL_add:
			case LITERAL_cmp:
			case LITERAL_shl:
			case LITERAL_shr:
			case LITERAL_sar:
			case LITERAL_setf:
			case LITERAL_ei:
			case LITERAL_trap:
			case LITERAL_ldsr:
			case LITERAL_stsr:
			case LITERAL_di:
			case LITERAL_bv:
			case LITERAL_bl:
			case LITERAL_be:
			case LITERAL_bnh:
			case LITERAL_bn:
			case LITERAL_br:
			case LITERAL_blt:
			case LITERAL_ble:
			case LITERAL_bnv:
			case LITERAL_bnl:
			case LITERAL_bne:
			case LITERAL_bh:
			case LITERAL_bp:
			case LITERAL_nop:
			case LITERAL_bge:
			case LITERAL_bgt:
			case LITERAL_jr:
			case LITERAL_jal:
			case LITERAL_movea:
			case LITERAL_addi:
			case LITERAL_ori:
			case LITERAL_andi:
			case LITERAL_xori:
			case LITERAL_movhi:
			case LITERAL_ld:
			case LITERAL_in:
			case LITERAL_caxi:
			case LITERAL_st:
			case LITERAL_out:
			case LITERAL_reti:
			case LITERAL_halt:
			{
				code();
				break;
			}
			default:
			{
				break _loop3;
			}
			}
		} while (true);
		}
		match(Token.EOF_TYPE);
	}
	
	public final int  org() throws ParserException, IOException {
		int tmp;
		
		tmp = -1;
		
		match(LITERAL_org);
		match(DOT);
		tmp=num();
		if ( guessing==0 ) {
			if(tmp < 0) {
					System.out.println("Error, org. is invalid: " + tmp); tmp = 0;} 
				
		}
		return tmp;
	}
	
	public final void preProc() throws ParserException, IOException {
		
		long tOrg = 0;
		
		switch ( LA(1)) {
		case LITERAL_db:
		case LITERAL_dh:
		case LITERAL_dw:
		{
			defNum();
			break;
		}
		case LITERAL_ds:
		{
			defStr();
			break;
		}
		case LITERAL_org:
		{
			tOrg=org();
			if ( guessing==0 ) {
				// Inlined Java Code, fills in the OBJ with zeros, to the new .org (Bad form)
						if (tOrg < tmp_PC+dout.getFilePointer()) {
							System.out.println("Error: org("+tOrg+") < CurPC("+(tmp_PC+dout.getFilePointer())+")");
						} else {
							while(tOrg > tmp_PC+dout.getFilePointer()) {
								dout.writeByte(0xFF);
							}
						}
					
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
	}
	
	public final void code() throws ParserException, IOException {
		
		int n = 0;
		
		try {      // for error handling
			n=opp();
			if ( guessing==0 ) {
				op_format[2] = n;
			}
			vars();
			if ( guessing==0 ) {
				
							op_format[1]=0; // Clear the opcode...
							//Case off of Op_Format[0]
							switch(op_format[0]) {
								case 10:        //Mode1, 2, 9
								case 20:
								case 90:
									op_format[1] = (((op_format[2]&0x3F) << 10) + ((op_format[4]&0x1F) << 5) + (op_format[3]&0x1F));
									dout.writeByte((byte)(op_format[1] &0xFF));
									dout.writeByte((byte)((op_format[1] >> 8) &0xFF));
									break;
								case 30:        //Mode3
									op_format[1] = (((op_format[2]&0x7F) << 9) + (op_format[3]&0x1FF));
									dout.writeByte((byte)(op_format[1] &0xFF));
									dout.writeByte((byte)((op_format[1] >> 8) &0xFF));
								break;
									case 40:        //Mode4
									op_format[1] = (((op_format[2]&0x3F) << 26) + (op_format[3]&0x3FFFFFF));
									dout.writeByte((byte)((op_format[1] >> 16) &0xFF));
									dout.writeByte((byte)((op_format[1] >> 24) &0xFF));
				
									dout.writeByte((byte)(op_format[1]         &0xFF));
									dout.writeByte((byte)((op_format[1] >>  8) &0xFF));
									break;
								case 50:        //Mode5, 6a
								case 60:
									op_format[1] = (((op_format[2]&0x3F) << 26) + ((op_format[5]&0x1F) << 21) + ((op_format[4]&0x1F)<< 16) + (op_format[3]&0xFFFF));
									dout.writeByte((byte)((op_format[1] >> 16) &0xFF));
									dout.writeByte((byte)((op_format[1] >> 24) &0xFF));
				
									dout.writeByte((byte)(op_format[1]         &0xFF));
									dout.writeByte((byte)((op_format[1] >>  8) &0xFF));
									break;
								case 61:        //Mode6b
									op_format[1] = (((op_format[2]&0x3F) << 26) + ((op_format[3]&0x1F) << 21) + ((op_format[5]&0x1F)<< 16) + (op_format[4]&0xFFFF));
									dout.writeByte((byte)((op_format[1] >> 16) &0xFF));
									dout.writeByte((byte)((op_format[1] >> 24) &0xFF));
				
									dout.writeByte((byte)(op_format[1]         &0xFF));
									dout.writeByte((byte)((op_format[1] >>  8) &0xFF));
									break;
								default:        //Ops, howd we get hear....
									break;
							}
							System.out.print("."); //Limit this more...
						
			}
		}
		catch (ParserException ex) {
			if (guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_0);
			} else {
			  throw ex;
			}
		}
	}
	
	public final void defNum() throws ParserException, IOException {
		
		int count = 0;
		
		switch ( LA(1)) {
		case LITERAL_db:
		{
			match(LITERAL_db);
			match(DOT);
			count=dnum();
			if ( guessing==0 ) {
				
						for(int i=0; i<count; i++) {      // Define Byte
							dout.writeByte((byte)(defBuff[i]&0xFF));
						}
					
			}
			break;
		}
		case LITERAL_dh:
		{
			match(LITERAL_dh);
			match(DOT);
			count=dnum();
			if ( guessing==0 ) {
				
						for(int i=0; i<count; i++) {      // Defien HWord
							dout.writeByte((byte)(defBuff[i]&0xFF));
							dout.writeByte((byte)((defBuff[i]>>8)&0xFF));
						}
					
			}
			break;
		}
		case LITERAL_dw:
		{
			match(LITERAL_dw);
			match(DOT);
			count=dnum();
			if ( guessing==0 ) {
				
						for(int i=0; i<count; i++) {      // Define Word
							dout.writeByte((byte)(defBuff[i]&0xFF));
							dout.writeByte((byte)((defBuff[i]>>8)&0xFF));
							dout.writeByte((byte)((defBuff[i]>>16)&0xFF));
							dout.writeByte((byte)((defBuff[i]>>24)&0xFF));
						}
					
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
	}
	
	public final void defStr() throws ParserException, IOException {
		
		Token  s = null;
		
		match(LITERAL_ds);
		match(DOT);
		s = LT(1);
		match(STR);
		if ( guessing==0 ) {
			dout.writeBytes(s.getText());
		}
	}
	
	public final int  num() throws ParserException, IOException {
		int n;
		
		Token  i = null;
		n=0;
		
		i = LT(1);
		match(INT);
		if ( guessing==0 ) {
			n=(Integer.valueOf(i.getText())).intValue();
		}
		return n;
	}
	
	public final int  dnum() throws ParserException, IOException {
		int count;
		
		
			int ret = 0;
			count = 0;
		
		
		ret=num();
		if ( guessing==0 ) {
			defBuff[count++]=ret;
		}
		{
		_loop10:
		do {
			if ((LA(1)==COMMA)) {
				match(COMMA);
				ret=num();
				if ( guessing==0 ) {
					defBuff[count++]=ret;
				}
			}
			else {
				break _loop10;
			}
			
		} while (true);
		}
		return count;
	}
	
	protected final int  opp() throws ParserException, IOException {
		int g;
		
		
			g = 0;
			int tmp = 0;
		
		
		switch ( LA(1)) {
		case LITERAL_sub:
		case LITERAL_jmp:
		case LITERAL_mul:
		case LITERAL_div:
		case LITERAL_mulu:
		case LITERAL_divu:
		case LITERAL_or:
		case LITERAL_and:
		case LITERAL_xor:
		case LITERAL_not:
		{
			{
			switch ( LA(1)) {
			case LITERAL_sub:
			{
				match(LITERAL_sub);
				if ( guessing==0 ) {
					g = 0x02;
				}
				break;
			}
			case LITERAL_jmp:
			{
				match(LITERAL_jmp);
				if ( guessing==0 ) {
					g = 0x06;
				}
				break;
			}
			case LITERAL_mul:
			{
				match(LITERAL_mul);
				if ( guessing==0 ) {
					g = 0x08;
				}
				break;
			}
			case LITERAL_div:
			{
				match(LITERAL_div);
				if ( guessing==0 ) {
					g = 0x09;
				}
				break;
			}
			case LITERAL_mulu:
			{
				match(LITERAL_mulu);
				if ( guessing==0 ) {
					g = 0x0A;
				}
				break;
			}
			case LITERAL_divu:
			{
				match(LITERAL_divu);
				if ( guessing==0 ) {
					g = 0x0B;
				}
				break;
			}
			case LITERAL_or:
			{
				match(LITERAL_or);
				if ( guessing==0 ) {
					g = 0x0C;
				}
				break;
			}
			case LITERAL_and:
			{
				match(LITERAL_and);
				if ( guessing==0 ) {
					g = 0x0D;
				}
				break;
			}
			case LITERAL_xor:
			{
				match(LITERAL_xor);
				if ( guessing==0 ) {
					g = 0x0E;
				}
				break;
			}
			case LITERAL_not:
			{
				match(LITERAL_not);
				if ( guessing==0 ) {
					g = 0x0F;
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1));
			}
			}
			}
			if ( guessing==0 ) {
				op_format[0] = 10;
			}
			break;
		}
		case LITERAL_mov:
		case LITERAL_add:
		case LITERAL_cmp:
		case LITERAL_shl:
		case LITERAL_shr:
		case LITERAL_sar:
		{
			{
			boolean synPredMatched20 = false;
			if (((LA(1)==LITERAL_mov) && (_tokenSet_1.member(LA(2))))) {
				int _m20 = mark();
				synPredMatched20 = true;
				guessing++;
				try {
					{
					match(LITERAL_mov);
					match(DOLAR);
					}
				}
				catch (ParserException pe) {
					synPredMatched20 = false;
				}
				rewind(_m20);
				guessing--;
			}
			if ( synPredMatched20 ) {
				match(LITERAL_mov);
				if ( guessing==0 ) {
					g = 0x00; op_format[0] = 10;
				}
			}
			else {
				boolean synPredMatched22 = false;
				if (((LA(1)==LITERAL_add) && (_tokenSet_1.member(LA(2))))) {
					int _m22 = mark();
					synPredMatched22 = true;
					guessing++;
					try {
						{
						match(LITERAL_add);
						match(DOLAR);
						}
					}
					catch (ParserException pe) {
						synPredMatched22 = false;
					}
					rewind(_m22);
					guessing--;
				}
				if ( synPredMatched22 ) {
					match(LITERAL_add);
					if ( guessing==0 ) {
						g = 0x01; op_format[0] = 10;
					}
				}
				else {
					boolean synPredMatched24 = false;
					if (((LA(1)==LITERAL_cmp) && (_tokenSet_1.member(LA(2))))) {
						int _m24 = mark();
						synPredMatched24 = true;
						guessing++;
						try {
							{
							match(LITERAL_cmp);
							match(DOLAR);
							}
						}
						catch (ParserException pe) {
							synPredMatched24 = false;
						}
						rewind(_m24);
						guessing--;
					}
					if ( synPredMatched24 ) {
						match(LITERAL_cmp);
						if ( guessing==0 ) {
							g = 0x03; op_format[0] = 10;
						}
					}
					else {
						boolean synPredMatched26 = false;
						if (((LA(1)==LITERAL_shl) && (_tokenSet_1.member(LA(2))))) {
							int _m26 = mark();
							synPredMatched26 = true;
							guessing++;
							try {
								{
								match(LITERAL_shl);
								match(DOLAR);
								}
							}
							catch (ParserException pe) {
								synPredMatched26 = false;
							}
							rewind(_m26);
							guessing--;
						}
						if ( synPredMatched26 ) {
							match(LITERAL_shl);
							if ( guessing==0 ) {
								g = 0x04; op_format[0] = 10;
							}
						}
						else {
							boolean synPredMatched28 = false;
							if (((LA(1)==LITERAL_shr) && (_tokenSet_1.member(LA(2))))) {
								int _m28 = mark();
								synPredMatched28 = true;
								guessing++;
								try {
									{
									match(LITERAL_shr);
									match(DOLAR);
									}
								}
								catch (ParserException pe) {
									synPredMatched28 = false;
								}
								rewind(_m28);
								guessing--;
							}
							if ( synPredMatched28 ) {
								match(LITERAL_shr);
								if ( guessing==0 ) {
									g = 0x05; op_format[0] = 10;
								}
							}
							else {
								boolean synPredMatched30 = false;
								if (((LA(1)==LITERAL_sar) && (_tokenSet_1.member(LA(2))))) {
									int _m30 = mark();
									synPredMatched30 = true;
									guessing++;
									try {
										{
										match(LITERAL_sar);
										match(DOLAR);
										}
									}
									catch (ParserException pe) {
										synPredMatched30 = false;
									}
									rewind(_m30);
									guessing--;
								}
								if ( synPredMatched30 ) {
									match(LITERAL_sar);
									if ( guessing==0 ) {
										g = 0x07; op_format[0] = 10;
									}
								}
								else if ((LA(1)==LITERAL_mov) && (_tokenSet_1.member(LA(2)))) {
									match(LITERAL_mov);
									if ( guessing==0 ) {
										g = 0x10; op_format[0] = 20;
									}
								}
								else if ((LA(1)==LITERAL_add) && (_tokenSet_1.member(LA(2)))) {
									match(LITERAL_add);
									if ( guessing==0 ) {
										g = 0x11; op_format[0] = 20;
									}
								}
								else if ((LA(1)==LITERAL_cmp) && (_tokenSet_1.member(LA(2)))) {
									match(LITERAL_cmp);
									if ( guessing==0 ) {
										g = 0x13; op_format[0] = 20;
									}
								}
								else if ((LA(1)==LITERAL_shl) && (_tokenSet_1.member(LA(2)))) {
									match(LITERAL_shl);
									if ( guessing==0 ) {
										g = 0x14; op_format[0] = 20;
									}
								}
								else if ((LA(1)==LITERAL_shr) && (_tokenSet_1.member(LA(2)))) {
									match(LITERAL_shr);
									if ( guessing==0 ) {
										g = 0x15; op_format[0] = 20;
									}
								}
								else if ((LA(1)==LITERAL_sar) && (_tokenSet_1.member(LA(2)))) {
									match(LITERAL_sar);
									if ( guessing==0 ) {
										g = 0x17; op_format[0] = 20;
									}
								}
								else {
									throw new NoViableAltException(LT(1));
								}
								}}}}}
								}
								break;
							}
							case LITERAL_setf:
							case LITERAL_ei:
							case LITERAL_trap:
							case LITERAL_ldsr:
							case LITERAL_stsr:
							case LITERAL_di:
							{
								{
								switch ( LA(1)) {
								case LITERAL_setf:
								{
									match(LITERAL_setf);
									if ( guessing==0 ) {
										g = 0x12;
									}
									break;
								}
								case LITERAL_ei:
								{
									match(LITERAL_ei);
									if ( guessing==0 ) {
										g = 0x16;
									}
									break;
								}
								case LITERAL_trap:
								{
									match(LITERAL_trap);
									if ( guessing==0 ) {
										g = 0x18;
									}
									break;
								}
								case LITERAL_ldsr:
								{
									match(LITERAL_ldsr);
									if ( guessing==0 ) {
										g = 0x1C;
									}
									break;
								}
								case LITERAL_stsr:
								{
									match(LITERAL_stsr);
									if ( guessing==0 ) {
										g = 0x1D;
									}
									break;
								}
								case LITERAL_di:
								{
									match(LITERAL_di);
									if ( guessing==0 ) {
										g = 0x1E;
									}
									break;
								}
								default:
								{
									throw new NoViableAltException(LT(1));
								}
								}
								}
								if ( guessing==0 ) {
									op_format[0] = 20;
								}
								break;
							}
							case LITERAL_bv:
							case LITERAL_bl:
							case LITERAL_be:
							case LITERAL_bnh:
							case LITERAL_bn:
							case LITERAL_br:
							case LITERAL_blt:
							case LITERAL_ble:
							case LITERAL_bnv:
							case LITERAL_bnl:
							case LITERAL_bne:
							case LITERAL_bh:
							case LITERAL_bp:
							case LITERAL_nop:
							case LITERAL_bge:
							case LITERAL_bgt:
							{
								{
								switch ( LA(1)) {
								case LITERAL_bv:
								{
									match(LITERAL_bv);
									if ( guessing==0 ) {
										g = 0x40;
									}
									break;
								}
								case LITERAL_bl:
								{
									match(LITERAL_bl);
									if ( guessing==0 ) {
										g = 0x41;
									}
									break;
								}
								case LITERAL_be:
								{
									match(LITERAL_be);
									if ( guessing==0 ) {
										g = 0x42;
									}
									break;
								}
								case LITERAL_bnh:
								{
									match(LITERAL_bnh);
									if ( guessing==0 ) {
										g = 0x43;
									}
									break;
								}
								case LITERAL_bn:
								{
									match(LITERAL_bn);
									if ( guessing==0 ) {
										g = 0x44;
									}
									break;
								}
								case LITERAL_br:
								{
									match(LITERAL_br);
									if ( guessing==0 ) {
										g = 0x45;
									}
									break;
								}
								case LITERAL_blt:
								{
									match(LITERAL_blt);
									if ( guessing==0 ) {
										g = 0x46;
									}
									break;
								}
								case LITERAL_ble:
								{
									match(LITERAL_ble);
									if ( guessing==0 ) {
										g = 0x47;
									}
									break;
								}
								case LITERAL_bnv:
								{
									match(LITERAL_bnv);
									if ( guessing==0 ) {
										g = 0x48;
									}
									break;
								}
								case LITERAL_bnl:
								{
									match(LITERAL_bnl);
									if ( guessing==0 ) {
										g = 0x49;
									}
									break;
								}
								case LITERAL_bne:
								{
									match(LITERAL_bne);
									if ( guessing==0 ) {
										g = 0x4A;
									}
									break;
								}
								case LITERAL_bh:
								{
									match(LITERAL_bh);
									if ( guessing==0 ) {
										g = 0x4B;
									}
									break;
								}
								case LITERAL_bp:
								{
									match(LITERAL_bp);
									if ( guessing==0 ) {
										g = 0x4C;
									}
									break;
								}
								case LITERAL_nop:
								{
									match(LITERAL_nop);
									if ( guessing==0 ) {
										g = 0x4D;
									}
									break;
								}
								case LITERAL_bge:
								{
									match(LITERAL_bge);
									if ( guessing==0 ) {
										g = 0x4E;
									}
									break;
								}
								case LITERAL_bgt:
								{
									match(LITERAL_bgt);
									if ( guessing==0 ) {
										g = 0x4F;
									}
									break;
								}
								default:
								{
									throw new NoViableAltException(LT(1));
								}
								}
								}
								if ( guessing==0 ) {
									op_format[0] = 30;
								}
								break;
							}
							case LITERAL_jr:
							case LITERAL_jal:
							{
								{
								switch ( LA(1)) {
								case LITERAL_jr:
								{
									match(LITERAL_jr);
									if ( guessing==0 ) {
										g = 0x2A;
									}
									break;
								}
								case LITERAL_jal:
								{
									match(LITERAL_jal);
									if ( guessing==0 ) {
										g = 0x2B;
									}
									break;
								}
								default:
								{
									throw new NoViableAltException(LT(1));
								}
								}
								}
								if ( guessing==0 ) {
									op_format[0] = 40;
								}
								break;
							}
							case LITERAL_movea:
							case LITERAL_addi:
							case LITERAL_ori:
							case LITERAL_andi:
							case LITERAL_xori:
							case LITERAL_movhi:
							{
								{
								switch ( LA(1)) {
								case LITERAL_movea:
								{
									match(LITERAL_movea);
									if ( guessing==0 ) {
										g = 0x28;
									}
									break;
								}
								case LITERAL_addi:
								{
									match(LITERAL_addi);
									if ( guessing==0 ) {
										g = 0x29;
									}
									break;
								}
								case LITERAL_ori:
								{
									match(LITERAL_ori);
									if ( guessing==0 ) {
										g = 0x2C;
									}
									break;
								}
								case LITERAL_andi:
								{
									match(LITERAL_andi);
									if ( guessing==0 ) {
										g = 0x2D;
									}
									break;
								}
								case LITERAL_xori:
								{
									match(LITERAL_xori);
									if ( guessing==0 ) {
										g = 0x2E;
									}
									break;
								}
								case LITERAL_movhi:
								{
									match(LITERAL_movhi);
									if ( guessing==0 ) {
										g = 0x2F;
									}
									break;
								}
								default:
								{
									throw new NoViableAltException(LT(1));
								}
								}
								}
								if ( guessing==0 ) {
									op_format[0] = 50;
								}
								break;
							}
							case LITERAL_ld:
							case LITERAL_in:
							case LITERAL_caxi:
							{
								{
								switch ( LA(1)) {
								case LITERAL_ld:
								{
									match(LITERAL_ld);
									match(DOT);
									{
									switch ( LA(1)) {
									case LITERAL_b:
									{
										match(LITERAL_b);
										if ( guessing==0 ) {
											g = 0x30;
										}
										break;
									}
									case LITERAL_h:
									{
										match(LITERAL_h);
										if ( guessing==0 ) {
											g = 0x31;
										}
										break;
									}
									case LITERAL_w:
									{
										match(LITERAL_w);
										if ( guessing==0 ) {
											g = 0x33;
										}
										break;
									}
									default:
									{
										throw new NoViableAltException(LT(1));
									}
									}
									}
									break;
								}
								case LITERAL_in:
								{
									match(LITERAL_in);
									match(DOT);
									{
									switch ( LA(1)) {
									case LITERAL_b:
									{
										match(LITERAL_b);
										if ( guessing==0 ) {
											g = 0x38;
										}
										break;
									}
									case LITERAL_h:
									{
										match(LITERAL_h);
										if ( guessing==0 ) {
											g = 0x39;
										}
										break;
									}
									case LITERAL_w:
									{
										match(LITERAL_w);
										if ( guessing==0 ) {
											g = 0x3B;
										}
										break;
									}
									default:
									{
										throw new NoViableAltException(LT(1));
									}
									}
									}
									break;
								}
								case LITERAL_caxi:
								{
									match(LITERAL_caxi);
									if ( guessing==0 ) {
										g = 0x3A;
									}
									break;
								}
								default:
								{
									throw new NoViableAltException(LT(1));
								}
								}
								}
								if ( guessing==0 ) {
									op_format[0] = 60;
								}
								break;
							}
							case LITERAL_st:
							case LITERAL_out:
							{
								{
								switch ( LA(1)) {
								case LITERAL_st:
								{
									match(LITERAL_st);
									match(DOT);
									{
									switch ( LA(1)) {
									case LITERAL_b:
									{
										match(LITERAL_b);
										if ( guessing==0 ) {
											g = 0x34;
										}
										break;
									}
									case LITERAL_h:
									{
										match(LITERAL_h);
										if ( guessing==0 ) {
											g = 0x35;
										}
										break;
									}
									case LITERAL_w:
									{
										match(LITERAL_w);
										if ( guessing==0 ) {
											g = 0x37;
										}
										break;
									}
									default:
									{
										throw new NoViableAltException(LT(1));
									}
									}
									}
									break;
								}
								case LITERAL_out:
								{
									match(LITERAL_out);
									match(DOT);
									{
									switch ( LA(1)) {
									case LITERAL_b:
									{
										match(LITERAL_b);
										if ( guessing==0 ) {
											g = 0x3C;
										}
										break;
									}
									case LITERAL_h:
									{
										match(LITERAL_h);
										if ( guessing==0 ) {
											g = 0x3D;
										}
										break;
									}
									case LITERAL_w:
									{
										match(LITERAL_w);
										if ( guessing==0 ) {
											g = 0x3F;
										}
										break;
									}
									default:
									{
										throw new NoViableAltException(LT(1));
									}
									}
									}
									break;
								}
								default:
								{
									throw new NoViableAltException(LT(1));
								}
								}
								}
								if ( guessing==0 ) {
									op_format[0] = 61;
								}
								break;
							}
							case LITERAL_reti:
							case LITERAL_halt:
							{
								{
								switch ( LA(1)) {
								case LITERAL_reti:
								{
									match(LITERAL_reti);
									if ( guessing==0 ) {
										g = 0x19;
									}
									break;
								}
								case LITERAL_halt:
								{
									match(LITERAL_halt);
									if ( guessing==0 ) {
										g = 0x1A;
									}
									break;
								}
								default:
								{
									throw new NoViableAltException(LT(1));
								}
								}
								}
								if ( guessing==0 ) {
									op_format[0] = 90;
								}
								break;
							}
							default:
							{
								throw new NoViableAltException(LT(1));
							}
							}
							return g;
						}
						
	public final void vars() throws ParserException, IOException {
		
		
			int n = 0;
			int count = 0;
			op_format[3]=0; //Zero the vars...
			op_format[4]=0;
			op_format[5]=0;
		
		
		switch ( LA(1)) {
		case EOF:
		case LITERAL_org:
		case LITERAL_db:
		case LITERAL_dh:
		case LITERAL_dw:
		case LITERAL_ds:
		case LITERAL_sub:
		case LITERAL_jmp:
		case LITERAL_mul:
		case LITERAL_div:
		case LITERAL_mulu:
		case LITERAL_divu:
		case LITERAL_or:
		case LITERAL_and:
		case LITERAL_xor:
		case LITERAL_not:
		case LITERAL_mov:
		case LITERAL_add:
		case LITERAL_cmp:
		case LITERAL_shl:
		case LITERAL_shr:
		case LITERAL_sar:
		case LITERAL_setf:
		case LITERAL_ei:
		case LITERAL_trap:
		case LITERAL_ldsr:
		case LITERAL_stsr:
		case LITERAL_di:
		case LITERAL_bv:
		case LITERAL_bl:
		case LITERAL_be:
		case LITERAL_bnh:
		case LITERAL_bn:
		case LITERAL_br:
		case LITERAL_blt:
		case LITERAL_ble:
		case LITERAL_bnv:
		case LITERAL_bnl:
		case LITERAL_bne:
		case LITERAL_bh:
		case LITERAL_bp:
		case LITERAL_nop:
		case LITERAL_bge:
		case LITERAL_bgt:
		case LITERAL_jr:
		case LITERAL_jal:
		case LITERAL_movea:
		case LITERAL_addi:
		case LITERAL_ori:
		case LITERAL_andi:
		case LITERAL_xori:
		case LITERAL_movhi:
		case LITERAL_ld:
		case LITERAL_in:
		case LITERAL_caxi:
		case LITERAL_st:
		case LITERAL_out:
		case LITERAL_reti:
		case LITERAL_halt:
		{
			break;
		}
		case DOLAR:
		case INT:
		{
			n=var();
			if ( guessing==0 ) {
				op_format[3+count] = n; count ++;
			}
			vars2(count);
			break;
		}
		case LBRACK:
		{
			match(LBRACK);
			n=var();
			match(RBRACK);
			if ( guessing==0 ) {
				op_format[3+count] = n; count ++;
			}
			vars2(count);
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
	}
	
	public final int  var() throws ParserException, IOException {
		int n;
		
		n = 0;
		
		try {      // for error handling
			switch ( LA(1)) {
			case DOLAR:
			{
				n=reg();
				break;
			}
			case INT:
			{
				n=num();
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1));
			}
			}
		}
		catch (ParserException ex) {
			if (guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_2);
			} else {
			  throw ex;
			}
		}
		return n;
	}
	
	public final void vars2(
		int count
	) throws ParserException, IOException {
		
		int n = 0;
		
		switch ( LA(1)) {
		case EOF:
		case LITERAL_org:
		case LITERAL_db:
		case LITERAL_dh:
		case LITERAL_dw:
		case LITERAL_ds:
		case LITERAL_sub:
		case LITERAL_jmp:
		case LITERAL_mul:
		case LITERAL_div:
		case LITERAL_mulu:
		case LITERAL_divu:
		case LITERAL_or:
		case LITERAL_and:
		case LITERAL_xor:
		case LITERAL_not:
		case LITERAL_mov:
		case LITERAL_add:
		case LITERAL_cmp:
		case LITERAL_shl:
		case LITERAL_shr:
		case LITERAL_sar:
		case LITERAL_setf:
		case LITERAL_ei:
		case LITERAL_trap:
		case LITERAL_ldsr:
		case LITERAL_stsr:
		case LITERAL_di:
		case LITERAL_bv:
		case LITERAL_bl:
		case LITERAL_be:
		case LITERAL_bnh:
		case LITERAL_bn:
		case LITERAL_br:
		case LITERAL_blt:
		case LITERAL_ble:
		case LITERAL_bnv:
		case LITERAL_bnl:
		case LITERAL_bne:
		case LITERAL_bh:
		case LITERAL_bp:
		case LITERAL_nop:
		case LITERAL_bge:
		case LITERAL_bgt:
		case LITERAL_jr:
		case LITERAL_jal:
		case LITERAL_movea:
		case LITERAL_addi:
		case LITERAL_ori:
		case LITERAL_andi:
		case LITERAL_xori:
		case LITERAL_movhi:
		case LITERAL_ld:
		case LITERAL_in:
		case LITERAL_caxi:
		case LITERAL_st:
		case LITERAL_out:
		case LITERAL_reti:
		case LITERAL_halt:
		{
			break;
		}
		case COMMA:
		{
			match(COMMA);
			n=var();
			if ( guessing==0 ) {
				op_format[3+count] = n; count ++;
			}
			vars2(count);
			break;
		}
		case LBRACK:
		{
			match(LBRACK);
			n=var();
			match(RBRACK);
			if ( guessing==0 ) {
				op_format[3+count] = n; count ++;
			}
			vars2(count);
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1));
		}
		}
	}
	
	public final int  reg() throws ParserException, IOException {
		int n;
		
		n=0;
		
		match(DOLAR);
		n=num();
		return n;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"\"org\"",
		"DOT",
		"\"db\"",
		"\"dh\"",
		"\"dw\"",
		"\"ds\"",
		"STR",
		"COMMA",
		"LBRACK",
		"RBRACK",
		"DOLAR",
		"\"sub\"",
		"\"jmp\"",
		"\"mul\"",
		"\"div\"",
		"\"mulu\"",
		"\"divu\"",
		"\"or\"",
		"\"and\"",
		"\"xor\"",
		"\"not\"",
		"\"mov\"",
		"\"add\"",
		"\"cmp\"",
		"\"shl\"",
		"\"shr\"",
		"\"sar\"",
		"\"setf\"",
		"\"ei\"",
		"\"trap\"",
		"\"ldsr\"",
		"\"stsr\"",
		"\"di\"",
		"\"bv\"",
		"\"bl\"",
		"\"be\"",
		"\"bnh\"",
		"\"bn\"",
		"\"br\"",
		"\"blt\"",
		"\"ble\"",
		"\"bnv\"",
		"\"bnl\"",
		"\"bne\"",
		"\"bh\"",
		"\"bp\"",
		"\"nop\"",
		"\"bge\"",
		"\"bgt\"",
		"\"jr\"",
		"\"jal\"",
		"\"movea\"",
		"\"addi\"",
		"\"ori\"",
		"\"andi\"",
		"\"xori\"",
		"\"movhi\"",
		"\"ld\"",
		"\"b\"",
		"\"h\"",
		"\"w\"",
		"\"in\"",
		"\"caxi\"",
		"\"st\"",
		"\"out\"",
		"\"reti\"",
		"\"halt\"",
		"INT",
		"LPAREN",
		"RPAREN",
		"LCURLY",
		"RCURLY",
		"COLON",
		"SEMI",
		"QUOTE",
		"WS",
		"SL_COMMENT",
		"ML_COMMENT",
		"CHAR_LITERAL",
		"ESC",
		"VOCAB",
		"IDENT",
		"OCT_DIGIT",
		"DEC_DIGIT",
		"HEX_DIGIT",
		"INT_INT"
	};
	
	private static final long _tokenSet_0_data_[] = { 4611686018427356114L, 126L, 0L, 0L };
	public static final BitSet _tokenSet_0 = new BitSet(_tokenSet_0_data_);
	private static final long _tokenSet_1_data_[] = { 4611686018427376594L, 254L, 0L, 0L };
	public static final BitSet _tokenSet_1 = new BitSet(_tokenSet_1_data_);
	private static final long _tokenSet_2_data_[] = { 4611686018427370450L, 126L, 0L, 0L };
	public static final BitSet _tokenSet_2 = new BitSet(_tokenSet_2_data_);
	
	}
